﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SomeDebuggerSkills
{
    internal sealed class MagicBeanListDebugView
    {
        private List<MagicBean> list;

        public MagicBeanListDebugView(List<MagicBean> list)
        {
            this.list = list;
        }

        [DebuggerBrowsable(DebuggerBrowsableState.RootHidden)]
        public MagicBean[] Items { get { return list.ToArray(); } }
    }

    [DebuggerDisplay("Count = {Count}")]
    [DebuggerTypeProxy(typeof(MagicBeanListDebugView))]
    public class MagicBeanList : List<MagicBean>
    {
        public MagicBeanList()
        {

        }

    }

    public class MagicBean
    {
        public int Key;

        public MagicBean(int key) { this.Key = key; }
    }
}
